Attribute VB_Name = "modPanelControl"
Option Explicit

' *** Den Artikel zu diesem Modul finden Sie unter http://www.aboutvb.de/khw/artikel/khwpanelcontrol.htm ***

Public Enum PanelControlErrorConstants
 pcErrInvalidPanelObject = 10001
 pcErrInvalidPanelIndexKey = 10002
End Enum

Public Function SetPanelControl(Control As Control, StatusBar As StatusBar, PanelKey As Variant, Optional ByVal AdjustStatusBarToControl As Boolean) As Long
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010     Dim nParent As Object
50020     Dim nOldParentWnd As Long
50030     Dim nPanel As Panel
50040
50050     With Control
50060         If TypeOf .Parent Is MDIForm Then
50070             Set nParent = .Container
50080         Else
50090             Set nParent = .Parent
50100         End If
50110     End With
50120     If IsObject(PanelKey) Then
50130         If TypeOf PanelKey Is Panel Then
50140             Set nPanel = PanelKey
50150         End If
50160     End If
50170     If nPanel Is Nothing Then
50180         Set nPanel = StatusBar.Panels(PanelKey)
50190     End If
50200     With Control
50210         nOldParentWnd = SetParent(.hwnd, StatusBar.hwnd)
50220         If GetWindowLong(.hwnd, GWL_USERDATA) = 0 Then
50230             SetWindowLong .hwnd, GWL_USERDATA, nOldParentWnd
50240         Else
50250             SetPanelControl = nOldParentWnd
50260         End If
50270     End With
50280     zAdjust Control, nParent, nPanel, StatusBar, AdjustStatusBarToControl
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modPanelControl", "SetPanelControl")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Sub RemovePanelControl(Control As Control, Optional OldParentWnd As Long)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010     With Control
50020         .Visible = False
50030         If OldParentWnd Then
50040             SetParent .hwnd, OldParentWnd
50050         Else
50060             SetParent .hwnd, GetWindowLong(.hwnd, GWL_USERDATA)
50070         End If
50080     End With
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modPanelControl", "RemovePanelControl")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Public Sub AdjustControlToPanel(Control As Control, StatusBar As StatusBar, PanelKey As Variant, Optional ByVal AdjustStatusBarToControl As Boolean)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010     Dim nParent As Object
50020     Dim nPanel As Panel
50030
50040     If IsObject(PanelKey) Then
50050         If TypeOf PanelKey Is Panel Then
50060             Set nPanel = PanelKey
50070         End If
50080     End If
50090     If nPanel Is Nothing Then
50100         Set nPanel = StatusBar.Panels(PanelKey)
50110     End If
50120     With Control
50130         If TypeOf .Parent Is MDIForm Then
50140             Set nParent = .Container
50150         Else
50160             Set nParent = .Parent
50170         End If
50180     End With
50190     zAdjust Control, nParent, nPanel, StatusBar, AdjustStatusBarToControl
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modPanelControl", "AdjustControlToPanel")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Private Sub zAdjust(Control As Control, Parent As Object, Panel As Panel, StatusBar As StatusBar, ByVal AdjustStatusBarToControl As Boolean)
    On Error Resume Next
    With Parent
        If AdjustStatusBarToControl Then
            StatusBar.Height = Control.Height + .ScaleY(6, vbPixels) + 50
            If Panel.Index = 1 Then
                Control.Move Panel.Left + .ScaleX(1, vbPixels), .ScaleY(4, vbPixels), Panel.Width - .ScaleX(3, vbPixels)
            Else
                Control.Move Panel.Left + .ScaleX(3, vbPixels), .ScaleY(4, vbPixels), Panel.Width - .ScaleX(4, vbPixels)
            End If
        Else
            If Panel.Index = 1 Then
                Control.Move Panel.Left + .ScaleX(1, vbPixels), .ScaleY(4, vbPixels), Panel.Width - .ScaleX(3, vbPixels), StatusBar.Height - .ScaleY(6, vbPixels)
            Else
                Control.Move Panel.Left + .ScaleX(3, vbPixels), .ScaleY(4, vbPixels), Panel.Width - .ScaleX(4, vbPixels), StatusBar.Height - .ScaleY(6, vbPixels)
            End If
        End If
    End With
End Sub

